<?php
/**
 * iNF | engine::function
 */
defined('__IN_iNF') or die('Error: Restricted Access!');
# # # # # # # # # # # # # # #

// сжатие
function G_en($x) { return gzencode($x, '9'); }
function G_de($x) { return gzdeflate($x, '9'); }

function __autoload($name) { require_once ROOT.'engine/classes/'.$name.'.class.php'; }

function iStrLen($m) { return mb_strlen($m, 'UTF-8'); }
function iSubStr($m, $s = 0, $d = 150) { return mb_SubStr($m, $s, $d, 'UTF-8'); }
function iStrRPos($h, $n, $o = NULL) { return mb_StrRPos($h, $n, $o, 'UTF-8'); }

function opis($m) { return br($m); }
function post($m) { return SmiLe(BBcode(opis($m))); }

function one($a) { return $a['0']; }

function amSQL($a)
{
global $sql;
	return  $sql->real_escape_string($a);
}

function iHTML($c)
{

	return htmlspecialchars(trim($c), ENT_QUOTES, 'UTF-8');
}

function move($go)
{
global $sql;
	header('Location: '.$go);
	$sql->close();
	Exit;
}

function SetLoad($act = 'autoload')
{
global $sql;
	$a = array();
	$q = $sql->query('SELECT `name`,`value` FROM `'.SET_TABLE."` WHERE `act` = '$act'");
	while ($s = $q->fetch_assoc())
	{
		$a[$s['name']] = $s['value'];
	}
return $a;
}

function SizeFile($s)
{
	$a = Array(' Байт', ' Кб', ' Мб', ' Гб', ' Тб');
	$i = Floor(Log($s, 1024));
return $s ? Round($s / Pow(1024, $i), 2).$a[$i] : '0 Байт';
}

function IcoFile($e)
{
	if ($e == '.gif' || $e == '.jpeg' || $e == '.jpg' || $e == '.png' || $e == '.bmp') $i = 'img.png';
	elseif ($e == '.mp4' || $e == '.mpeg' || $e == '.3gp' || $e == '.avi' || $e == '.flv') $i = 'video.png';
	elseif ($e == '.mp3' || $e == '.wav' || $e == '.amr' || $e == '.midi' || $e == '.mid' || $e == '.aac') $i = 'music.png';
	elseif ($e == '.thm' || $e == '.nth') $i = 'theme.png';
	elseif ($e == '.sis' || $e == '.sisx') $i = 'sis.png';
	elseif ($e == '.jar' || $e == '.jad') $i = 'java.png';
	elseif ($e == '.rar' || $e == '.zip' || $e == '.7z') $i = 'zip.png';
	else $i = 'file.png';
return '<img src="/data/file/'.$i.'" alt="#">';
}

function Translit($m)
{
$m = StrTR($m, Array('a' => 'а', 'b' => 'б', 'v' => 'в', 'g' => 'г', 'd' => 'д', 'e' => 'е', 'yo' => 'ё', 'zh' => 'ж', 'z' => 'з', 'i' => 'и', 'j' => 'й', 'k' => 'к', 'l' => 'л', 'm' => 'м', 'n' => 'н', 'o' => 'о', 'p' => 'п',
 'r' => 'р', 's' => 'с', 't' => 'т', 'u' => 'у', 'f' => 'ф', 'h' => 'х', 'c' => 'ц', 'ch' => 'ч', 'w' => 'ш', 'sh' => 'щ', 'q' => 'ъ', 'y' => 'ы', 'x' => 'э', 'yu' => 'ю', 'ya' => 'я'));
return StrTR($m, Array('A' => 'А', 'B' => 'Б', 'V' => 'В', 'G' => 'Г', 'D' => 'Д', 'E' => 'Е', 'YO' => 'Ё', 'ZH' => 'Ж', 'Z' => 'З', 'I' => 'И', 'J' => 'Й', 'K' => 'К', 'L' => 'Л', 'M' => 'М', 'N' => 'Н', 'O' => 'О', 'P' => 'П',
 'R' => 'Р', 'S' => 'С', 'T' => 'Т', 'U' => 'У', 'F' => 'Ф', 'H' => 'Х', 'C' => 'Ц', 'CH' => 'Ч', 'W' => 'Ш', 'SH' => 'Щ', 'Q' => 'Ъ', 'Y' => 'Ы', 'X' => 'Э', 'YU' => 'Ю', 'YA' => 'Я'));
}

function makestime($string)
{
 $day = floor($string / 86400);
 $hours = floor(($string / 3600) - $day * 24);
 $min = floor(($string - $hours * 3600 - $day * 86400) / 60);
 $sec = $string - ($min * 60 + $hours * 3600 + $day * 86400);

 return sprintf("%01d дн. %02d:%02d<small>:%02d</small>", $day, $hours, $min, $sec);
}

function vTime($time){
$timep="".date("j M Y в G:i", $time)."";
$time_p[0]=date("j n Y", $time);
$time_p[1]=date("G:i", $time);
if ($time_p[0]==date("j n Y"))$timep=date("сегодня в G:i", $time);
if ($time_p[0]==date("j n Y", time()-60*60*24))$timep="вчера в $time_p[1]";
$timep=str_replace("Jan","янв",$timep);
$timep=str_replace("Feb","фев",$timep);
$timep=str_replace("Mar","марта",$timep);
$timep=str_replace("May","мая",$timep);
$timep=str_replace("Apr","Апр",$timep);
$timep=str_replace("Jun","июня",$timep);
$timep=str_replace("Jul","июля",$timep);
$timep=str_replace("Aug","авг",$timep);
$timep=str_replace("Sep","сент",$timep);
$timep=str_replace("Oct","окт",$timep);
$timep=str_replace("Nov","ноября",$timep);
$timep=str_replace("Dec","дек",$timep);
return $timep;
}

function _SESSION($div_c = '<div class="msg">', $div = '</div>')
{
	if (isSet($_SESSION['echo']))
	{
	echo $div_c , $_SESSION['echo'] , $div;
	unSet($_SESSION['echo']);
	}
}


function br($m){ 
$m = str_replace("\n","<br />",$m);
return $m;}

function code_php($php){
$php=strtr($php,array("&lt;"=>"<","&gt;"=>">","&amp;"=>"&","&#36;"=>"\$","&quot;"=>"\"","&#39;"=>"'","&#92;"=>"\\","&#37;"=>"%","<br />"=>"\r\n","&#94;"=>"^","&#58;"=>":"));
$php=strtr($php,array('&#039;'=>'"'));
$php = highlight_string(trim($php),true);
$php = '<div class="quote">'.$php.' </div>';
$php=strtr($php,array("&amp;nbsp;"=>" "));
return $php;}
function url_replace_bb($m)
{
 if (!isset($m[3])) {
  return '<a href="' . $m[1] . '">' . $m[2] . '</a>';
 } else {
  return '<a href="' . $m[3] . '">' . $m[3] . '</a>';
 } 
} 
function BBcode($m)
{
$m = preg_replace_callback('~\\[url=(.+?)\\](.+?)\\[/url\\]|(http://(www.)?[0-9a-z\.-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', 'url_replace_bb', $m);
$m = preg_replace(array('#\[code\](.*?)\[\/code\]#se'), array("''.code_php('$1').''"), $m);
$m = str_replace('[br]', '<br/>', $m);
$m = str_replace('[hr]', '<hr/>', $m);
$m = preg_replace('#\[b\](.*?)\[/b\]#si', '<b>\1</b>', $m);
$m = preg_replace('#\[i\](.*?)\[/i\]#si', '<i>\1</i>', $m);
$m = preg_replace('#\[u\](.*?)\[/u\]#si', '<u>\1</u>', $m);
$m = preg_replace('#\[del\](.*?)\[/del\]#si', '<del>\1</del>', $m);
$m = preg_replace('#\[big\](.*?)\[/big\]#si', '<big>\1</big>', $m);
$m = preg_replace('#\[small\](.*?)\[/small\]#si', '<small>\1</small>', $m);
$m = preg_replace('#\[red\](.*?)\[/red\]#si', '<font color="red">\1</font>', $m);
$m = preg_replace('#\[green\](.*?)\[\/green\]#si', '<font color="green">\1</font>', $m);
$m = preg_replace('#\[blue\](.*?)\[/blue\]#si', '<font color="#0000FF">\1</font>', $m);
$m = preg_replace('#\[yellow\](.*?)\[/yellow\]#si', '<font color="#FFFF00">\1</font>', $m);
$m = preg_replace('#\[quote\](.*?)\[/quote\]#si', '<div class="quote"><b>Цитата</b>: \1 <br/><br/>', $m);
$m = preg_replace('#\[end\]#si', '</div>', $m);
//$m = preg_replace_callback('~\\[url=(http://.+?)\\](.+?)\\[/url\\]|(http://(www.)?[0-9a-z\.-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', 'url_replace_bb', $m);
return $m;
}

function Smile($m)
{
$i = '/data/smiles/'; // путь к смайлам
# осторожно... вынос мозга:
return StrTR($m, Array(
# =)
' =)' => '<img src="'.$i.'ulib.gif" alt=": )"> ',
' :)' => '<img src="'.$i.'ulib.gif" alt=": )"> ',
' :-)' => '<img src="'.$i.'ulib.gif" alt=": )"> ',
# =(
' =(' => '<img src="'.$i.'sad.gif" alt=": ("> ',
' :(' => '<img src="'.$i.'sad.gif" alt=": ("> ',
' :-(' => '<img src="'.$i.'sad.gif" alt=": ("> ',
# ;)
' ;)' => '<img src="'.$i.'pod.gif" alt="; )"> ',
' ;-)' => '<img src="'.$i.'pod.gif" alt="; )"> ',
# :D
' :D' => '<img src="'.$i.'d.gif" alt=": D"> ',
' :-D' => '<img src="'.$i.'d.gif" alt=": D"> ',
' :d' => '<img src="'.$i.'d.gif" alt=": D"> ',
' :-d' => '<img src="'.$i.'d.gif" alt=": D"> ',
# bye
' :bye:' => '<img src="'.$i.'bye.gif" alt="BYE"> ',
' 0^' => '<img src="'.$i.'bye.gif" alt="BYE"> ',
' O^' => '<img src="'.$i.'bye.gif" alt="BYE"> ',
# %%
' %-E' => '<img src="'.$i.'gig.gif" alt="%E"> ',
' %-e' => '<img src="'.$i.'gig.gif" alt="%E"> ',
# ok
' :ok:' => '<img src="'.$i.'ok.gif" alt="OK"> ',
' :OK:' => '<img src="'.$i.'ok.gif" alt="OK"> ',
# friend
' d00b' => '<img src="'.$i.'fri.gif" alt="FRIENDs"> ',
' dOOb' => '<img src="'.$i.'fri.gif" alt="FRIENDs"> ',
# thumbs up
' Ob' => '<img src="'.$i.'goo.gif" alt="THUMBS UP"> ',
' 0b' => '<img src="'.$i.'goo.gif" alt="THUMBS UP"> ',
' ob' => '<img src="'.$i.'goo.gif" alt="THUMBS UP"> ',
# fingal
' 6-(' => '<img src="'.$i.'fin.gif" alt="ФИНГАЛ"> ',
# devil
' ]:-&gt;' => '<img src="'.$i.'evil.gif" alt="DEVIL"> ',
# angel
' 0:-)' => '<img src="'.$i.'ang.gif" alt="ANGEL"> ',
' O:-)' => '<img src="'.$i.'ang.gif" alt="ANGEL"> ',
# :-[
' :-[' => '<img src="'.$i.'blu.gif" alt=": ["> ',
# :-p
' :-P' => '<img src="'.$i.'p.gif" alt=": P"> ',
' :P' => '<img src="'.$i.'p.gif" alt=": P"> ',
' :-p' => '<img src="'.$i.'p.gif" alt=": P"> ',
' :p' => '<img src="'.$i.'p.gif" alt=": P"> ',
# :-]
' :-]' => '<img src="'.$i.'dov.gif" alt=": ]"> ',
' :]' => '<img src="'.$i.'dov.gif" alt=": ]"> ',
# :'(
' :&#039;(' => '<img src="'.$i.'cry.gif" alt=":\' ("> ',
' :&#039;-(' => '<img src="'.$i.'cry.gif" alt=":\' ("> ',
# :-\
' :-/' => '<img src="'.$i.'hm.gif" alt=": /"> ',
' :-\\' => '<img src="'.$i.'hm.gif" alt=": /"> ',
# 8)
' 8)' => '<img src="'.$i.'8.gif" alt="8 )"> ',
' 8-)' => '<img src="'.$i.'hm.gif" alt="8 )"> ',
# :-*
' :-*' => '<img src="'.$i.'kis.gif" alt=": *"> ',
' :*' => '<img src="'.$i.'kis.gif" alt=": *"> ',
# %)
' %)' => '<img src="'.$i.'cra.gif" alt="CRAZY"> ',
# браво
' :bravo:' => '<img src="'.$i.'bra.gif" alt="BRAVO"> ',
' :BRAVO:' => '<img src="'.$i.'bra.gif" alt="BRAVO"> ',
# фига
' :fig:' => '<img src="'.$i.'fig.gif" alt="FIG"> ',
' :FIG:' => '<img src="'.$i.'fig.gif" alt="FIG"> ',
# Гы гы
' :gigi:' => '<img src="'.$i.'gih.gif" alt="ГЫ ГЫ"> ',
' :GIGI:' => '<img src="'.$i.'gih.gif" alt="ГЫ ГЫ"> ',
# 0_0
' 0_0' => '<img src="'.$i.'cho.gif" alt="0_о"> ', 'O_O' => '<img src="'.$i.'cho.gif" alt="0_о"> ',
' 0_o' => '<img src="'.$i.'cho.gif" alt="0_о"> ', 'o_0' => '<img src="'.$i.'cho.gif" alt="0_о"> ',
' O_o' => '<img src="'.$i.'cho.gif" alt="0_о"> ', 'o_O' => '<img src="'.$i.'cho.gif" alt="0_о"> ',
' :-0' => '<img src="'.$i.'cho.gif" alt="0_о"> ', ':-O' => '<img src="'.$i.'cho.gif" alt="0_о"> ',
# крутой
' :krut:' => '<img src="'.$i.'pal.gif" alt="Крут"> ',
' :KRUT:' => '<img src="'.$i.'pal.gif" alt="Крут"> '
));
}

function user_info($id = 0, $sel = '*')
{
    global $sql;
	$a['id'] = $id;
	$q = $sql->query('SELECT '.$sel.' FROM `'.USER_TABLE.'` WHERE `id` = '.$a['id'].' LIMIT 1');
	if ($q->num_rows > 0) $a = $q->fetch_array();
	else $a['nick'] = 'Anonymous';
	return $a;
}

function online($u, $p)
{
    $t = $_SERVER['REQUEST_TIME'] - 300;
    $T = $t - ON_TIME;
	if ($u > $t) return '<img src="/data/on.gif" alt="on"/>';
	else
	{
	 if ($p == '1') return '<img src="/data/off.gif" alt="off"/>';
	 else return '<img src="/data/off.gif" alt="off"/>';
	}

}
function u_online() {
$username = getenv("REMOTE_ADDR");
$ua = mysql_real_escape_string($_SERVER['HTTP_USER_AGENT']);

 if (preg_match('/(Opera|Firefox|Safari|YandexBot|Googlebot|Googlebot-Mobile|MJ12bot|AhrefsBot|Flock|MSIE|K-Meleon|SeaMonkey|Camino|Firebird|Epiphany|Chrome|America Online Browser)[\/: ]([\d.]+)/', $ua, $out)) {
	 if ($out[1] == "MSIE") {
     $out[1] = "Internet Explorer";
    } 
    $ua = $out[1] . " " . $out[2];
   }

$past = time()-300;

mysql_query("DELETE FROM online WHERE time < $past");
$result = mysql_query("SELECT time FROM online WHERE ip='$username'");

$ctime = time();

if ($row = mysql_fetch_array($result)) {
mysql_query("UPDATE online SET ip='$username', time='$ctime', ua='$ua' WHERE ip='$username'");
} else {
mysql_query("INSERT INTO online (ip, time, ua) VALUES ('$username', '$ctime', '$ua')");
}
# считывание результатов
$_tm = $_SERVER['REQUEST_TIME']-300;
$result_g = mysql_query ("SELECT COUNT(*) FROM online") or die ("Can't select result");
$result_u = mysql_query ('SELECT COUNT(*) FROM `'.USER_TABLE.'`  WHERE `timeaut` > '.$_tm);
$count_g = mysql_fetch_array($result_g);
$count_u = mysql_fetch_array($result_u);
echo '(<a href="/users_on.php">'.$count_u[0].'</a>';
echo '/';
echo '<a href="/guests_on.php">'.$count_g[0].'</a>)';
}
// алгоритм шифрования
function iCrypt($p)
{
	return MD5(base64_ENcode(crypt(MD5(trim($p)), CRYPT_MD5))); # фак.мой.мозг
}

?>
