-- phpMyAdmin SQL Dump
-- version 3.4.3.2
-- http://www.phpmyadmin.net
--
-- Хост: 10.0.0.71:3306
-- Время создания: Фев 11 2012 г., 22:27
-- Версия сервера: 5.1.61
-- Версия PHP: 5.3.9-ZS5.6.0

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- База данных: `ferrari`
--

-- --------------------------------------------------------

--
-- Структура таблицы `adm_forum_p`
--

CREATE TABLE IF NOT EXISTS `adm_forum_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `t` int(11) NOT NULL,
  `c` int(11) DEFAULT '0',
  `user` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `time_ed` int(11) DEFAULT NULL,
  `ed` int(11) DEFAULT '0',
  `user_ed` int(11) DEFAULT NULL,
  `msg` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `them` (`t`),
  KEY `user` (`user`),
  KEY `time` (`time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;



-- --------------------------------------------------------

--
-- Структура таблицы `adm_forum_t`
--

CREATE TABLE IF NOT EXISTS `adm_forum_t` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) NOT NULL,
  `user` int(11) DEFAULT NULL,
  `time` int(11) NOT NULL,
  `post` int(11) DEFAULT '0',
  `time_last` int(11) NOT NULL,
  `user_last` int(11) DEFAULT NULL,
  `up` set('0','1') NOT NULL DEFAULT '0',
  `close` set('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;



-- --------------------------------------------------------

--
-- Структура таблицы `ban_text`
--

CREATE TABLE IF NOT EXISTS `ban_text` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `text` char(255) NOT NULL,
  `time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;



-- --------------------------------------------------------

--
-- Структура таблицы `base_info`
--

CREATE TABLE IF NOT EXISTS `base_info` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` char(128) NOT NULL,
  `value` char(255) NOT NULL,
  `act` char(32) DEFAULT 'base',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;



-- --------------------------------------------------------

--
-- Структура таблицы `files`
--

CREATE TABLE IF NOT EXISTS `files` (
  `id` bigint(16) unsigned NOT NULL AUTO_INCREMENT,
  `path` char(255) NOT NULL,
  `infolder` char(255) NOT NULL,
  `name` char(255) NOT NULL,
  `keywords` varchar(500) NOT NULL,
  `description` varchar(500) NOT NULL,
  `id_user` int(10) NOT NULL,
  `priority` tinyint(3) NOT NULL DEFAULT '0',
  `size` int(11) unsigned NOT NULL,
  `about` varchar(2048) NOT NULL,
  `fastabout` varchar(1024) NOT NULL,
  `loads` int(16) unsigned NOT NULL DEFAULT '0',
  `timeload` int(11) unsigned NOT NULL,
  `timeupload` int(11) unsigned NOT NULL,
  `lastedit` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `size` (`size`),
  KEY `path` (`path`),
  KEY `infolder` (`infolder`),
  KEY `name` (`name`),
  KEY `loads` (`loads`),
  KEY `priority` (`priority`),
  KEY `timeupload` (`timeupload`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;



-- --------------------------------------------------------

--
-- Структура таблицы `files_komm`
--

CREATE TABLE IF NOT EXISTS `files_komm` (
  `id` bigint(16) unsigned NOT NULL AUTO_INCREMENT,
  `where` bigint(16) unsigned NOT NULL,
  `user` int(11) NOT NULL,
  `msg` varchar(500) NOT NULL,
  `time` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `file_id` (`where`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;



-- --------------------------------------------------------

--
-- Структура таблицы `files_screen`
--

CREATE TABLE IF NOT EXISTS `files_screen` (
  `id` bigint(16) unsigned NOT NULL AUTO_INCREMENT,
  `path` char(255) NOT NULL,
  `id_file` bigint(16) unsigned NOT NULL,
  `alt` char(32) NOT NULL,
  `opis` varchar(1024) NOT NULL,
  `time` int(11) NOT NULL DEFAULT '0',
  `pr` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id_file` (`id_file`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `forum_f`
--

CREATE TABLE IF NOT EXISTS `forum_f` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL,
  `mesto` int(11) NOT NULL,
  `opis` varchar(512) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;


-- --------------------------------------------------------

--
-- Структура таблицы `forum_p`
--

CREATE TABLE IF NOT EXISTS `forum_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `f` int(11) NOT NULL,
  `r` int(11) NOT NULL,
  `t` int(11) NOT NULL,
  `c` int(11) DEFAULT '0',
  `user` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `time_ed` int(11) DEFAULT NULL,
  `ed` int(11) DEFAULT '0',
  `user_ed` int(11) DEFAULT NULL,
  `msg` text NOT NULL,
  `file` varchar(250) DEFAULT NULL,
  `fname` varchar(64) DEFAULT NULL,
  `ext` varchar(32) DEFAULT '',
  `fsize` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `them` (`f`,`r`,`t`),
  KEY `user` (`user`),
  KEY `time` (`time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;



-- --------------------------------------------------------

--
-- Структура таблицы `forum_r`
--

CREATE TABLE IF NOT EXISTS `forum_r` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `f` int(11) NOT NULL,
  `name` varchar(64) NOT NULL,
  `opis` varchar(250) DEFAULT NULL,
  `time` int(11) NOT NULL,
  `p` int(11) DEFAULT '0',
  `t` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `forum` (`f`,`time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=21 ;



-- --------------------------------------------------------

--
-- Структура таблицы `forum_t`
--

CREATE TABLE IF NOT EXISTS `forum_t` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `f` int(11) NOT NULL,
  `r` int(11) DEFAULT NULL,
  `name` varchar(128) NOT NULL,
  `user` int(11) DEFAULT NULL,
  `time` int(11) NOT NULL,
  `post` int(11) DEFAULT '0',
  `time_last` int(11) NOT NULL,
  `user_last` int(11) DEFAULT NULL,
  `up` set('0','1') NOT NULL DEFAULT '0',
  `close` set('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id_forum` (`f`,`r`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;



-- --------------------------------------------------------

--
-- Структура таблицы `forum_x`
--

CREATE TABLE IF NOT EXISTS `forum_x` (
  `topic_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`topic_id`,`user_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



-- --------------------------------------------------------

--
-- Структура таблицы `foto_album`
--

CREATE TABLE IF NOT EXISTS `foto_album` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` char(128) COLLATE utf8_unicode_ci DEFAULT NULL,
  `opis` char(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `user` int(11) NOT NULL DEFAULT '0',
  `time` int(11) NOT NULL DEFAULT '0',
  `last` int(11) NOT NULL DEFAULT '0',
  `all` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user` (`user`,`last`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;



-- --------------------------------------------------------

--
-- Структура таблицы `foto_file`
--

CREATE TABLE IF NOT EXISTS `foto_file` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `album` int(11) NOT NULL,
  `user` int(11) NOT NULL,
  `file` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
  `name` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
  `opis` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `size` int(11) DEFAULT NULL,
  `x` int(6) DEFAULT NULL,
  `y` int(6) DEFAULT NULL,
  `komm` int(11) DEFAULT '0',
  `time` int(11) NOT NULL,
  `V` int(11) DEFAULT '0',
  `O` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;



-- --------------------------------------------------------

--
-- Структура таблицы `foto_komm`
--

CREATE TABLE IF NOT EXISTS `foto_komm` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL DEFAULT '0',
  `where` int(11) NOT NULL DEFAULT '0',
  `msg` varchar(500) COLLATE utf8_unicode_ci DEFAULT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `foto_voice`
--

CREATE TABLE IF NOT EXISTS `foto_voice` (
  `user` int(11) NOT NULL DEFAULT '0',
  `foto` int(11) NOT NULL DEFAULT '0',
  KEY `user` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Структура таблицы `guest`
--

CREATE TABLE IF NOT EXISTS `guest` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL DEFAULT '0',
  `msg` varchar(1024) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `otv_msg` varchar(200) NOT NULL,
  `otv_user` int(8) NOT NULL,
  `otv_time` int(13) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=60 ;


--
-- Структура таблицы `kl`
--

CREATE TABLE IF NOT EXISTS `kl` (
  `user` int(11) NOT NULL,
  `kont` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `last` int(11) NOT NULL,
  `aut` set('0','1') COLLATE utf8_unicode_ci NOT NULL DEFAULT '1',
  PRIMARY KEY (`user`,`kont`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


-- --------------------------------------------------------

--
-- Структура таблицы `lib`
--

CREATE TABLE IF NOT EXISTS `lib` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `in_dir` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `is_dir` set('0','1') NOT NULL DEFAULT '0',
  `posting` set('0','1') DEFAULT '0',
  `name` char(250) NOT NULL,
  `opis` varchar(500) NOT NULL,
  `user` int(11) NOT NULL,
  `text` longtext NOT NULL,
  `is_mod` set('0','1') NOT NULL DEFAULT '0',
  `count` int(5) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `type` (`is_dir`),
  KEY `moder` (`is_mod`),
  KEY `time` (`time`),
  KEY `refid` (`in_dir`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `lib_moder`
--

CREATE TABLE IF NOT EXISTS `lib_moder` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `in_dir` int(11) NOT NULL,
  `edit_id` int(11) DEFAULT '0',
  `time` int(11) NOT NULL,
  `name` char(250) NOT NULL,
  `user` int(11) NOT NULL,
  `text` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `mail`
--

CREATE TABLE IF NOT EXISTS `mail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) DEFAULT NULL,
  `kont` int(11) DEFAULT NULL,
  `msg` varchar(2000) COLLATE utf8_unicode_ci DEFAULT NULL,
  `read` set('0','1') COLLATE utf8_unicode_ci DEFAULT '0',
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ser` (`user`,`kont`),
  KEY `time` (`time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=44 ;


--
-- Структура таблицы `mp3_file`
--

CREATE TABLE IF NOT EXISTS `mp3_file` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `file` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
  `name` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
  `opis` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `size` int(11) DEFAULT NULL,
  `komm` int(11) DEFAULT '0',
  `time` int(11) NOT NULL,
  `V` int(11) DEFAULT '0',
  `O` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `mp3_komm`
--

CREATE TABLE IF NOT EXISTS `mp3_komm` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL DEFAULT '0',
  `mp3` int(11) NOT NULL DEFAULT '0',
  `msg` varchar(500) COLLATE utf8_unicode_ci DEFAULT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `mp3_voice`
--

CREATE TABLE IF NOT EXISTS `mp3_voice` (
  `user` int(11) NOT NULL DEFAULT '0',
  `mp3` int(11) NOT NULL DEFAULT '0',
  KEY `user` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Структура таблицы `news`
--

CREATE TABLE IF NOT EXISTS `news` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) DEFAULT NULL,
  `name` char(250) COLLATE utf8_unicode_ci DEFAULT NULL,
  `text` varchar(2000) COLLATE utf8_unicode_ci DEFAULT NULL,
  `time` int(11) NOT NULL,
  `is_komm` set('0','1') COLLATE utf8_unicode_ci DEFAULT '1',
  `komm` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;

--
-- Дамп данных таблицы `news`
--

INSERT INTO `news` (`id`, `user`, `name`, `text`, `time`, `is_komm`, `komm`) VALUES
(1, 1, 'Новое', 'Совсем скоро получите движок, который перед Вами. Соберу архив, поисправлю ошибки.', 1328911901, '1', 3);

-- --------------------------------------------------------

--
-- Структура таблицы `news_komm`
--

CREATE TABLE IF NOT EXISTS `news_komm` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL DEFAULT '0',
  `where` int(11) NOT NULL DEFAULT '0',
  `msg` varchar(1024) COLLATE utf8_unicode_ci DEFAULT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;

--
-- Дамп данных таблицы `news_komm`
--

INSERT INTO `news_komm` (`id`, `user`, `where`, `msg`, `time`) VALUES
(1, 1, 1, 'сейчас сижу делаю подключение к бд через класс. заеб!', 1328973257),
(2, 2, 1, 'Делай! народ тебе спосибо скажет, не захочет по хорошему заставим! :D', 1328974979),
(3, 11, 1, 'Вижу до форума добралсь)', 1328975059);

-- --------------------------------------------------------

--
-- Структура таблицы `new_action`
--

CREATE TABLE IF NOT EXISTS `new_action` (
  `id` bigint(16) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `text` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `time` int(11) NOT NULL DEFAULT '0',
  `read` set('0','1') DEFAULT '0',
  `act` char(128) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`user`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `online`
--

CREATE TABLE IF NOT EXISTS `online` (
  `id` int(30) NOT NULL AUTO_INCREMENT,
  `ip` char(15) COLLATE utf8_unicode_ci DEFAULT NULL,
  `ua` varchar(200) CHARACTER SET cp1251 NOT NULL,
  `time` int(11) NOT NULL,
  UNIQUE KEY `id` (`id`),
  KEY `ip` (`ip`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=415 ;

--
-- Дамп данных таблицы `online`
--

INSERT INTO `online` (`id`, `ip`, `ua`, `time`) VALUES
(404, '46.0.208.98', 'Opera 9.80', 1328984839),
(410, '188.232.218.243', 'Chrome 16.0.912.77', 1328984590),
(411, '66.249.66.52', 'Googlebot 2.1', 1328984563),
(412, '213.87.120.151', 'Opera 9.64', 1328984751),
(413, '82.145.208.162', 'Opera 9.80', 1328984717),
(414, '77.122.59.47', 'Chrome 17.0.963.46', 1328984761);

-- --------------------------------------------------------

--
-- Структура таблицы `pass_back`
--

CREATE TABLE IF NOT EXISTS `pass_back` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `mail` char(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `md5` char(250) COLLATE utf8_unicode_ci NOT NULL,
  `time` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `plagins`
--

CREATE TABLE IF NOT EXISTS `plagins` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` char(128) NOT NULL,
  `url` char(255) NOT NULL,
  `about` char(250) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- Дамп данных таблицы `plagins`
--

INSERT INTO `plagins` (`id`, `name`, `url`, `about`) VALUES
(1, 'Форум', 'admin/forum.php', NULL),
(2, 'Фотогаллерея', 'foto/', NULL),
(3, 'Загруз-Центр', 'load/', '');

-- --------------------------------------------------------

--
-- Структура таблицы `reg_mail`
--

CREATE TABLE IF NOT EXISTS `reg_mail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `mail` char(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `md5` char(250) COLLATE utf8_unicode_ci NOT NULL,
  `time` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=14 ;

--
-- Дамп данных таблицы `reg_mail`
--

INSERT INTO `reg_mail` (`id`, `user`, `mail`, `md5`, `time`) VALUES
(1, 0, 'xanoi@bk.ru', 'e27edbae548130b78f4c3df42f71034c', 1328910328),
(2, 0, 'wapxos@mail.ru', '0fe7d400f11ad6d79dc8b7b5dba4c25b', 1328958602),
(3, 0, 'pritis.a@yandex.ru', '03d177282a22e7605594c898e2609b91', 1328958642),
(4, 0, 'sky_mr@mail.ru', '91664893ad492b0f349339855bf5426a', 1328958856),
(5, 0, 'admin@friendka.tk', '7d41fb61ae991fddb8e922845d3d2710', 1328959998),
(6, 0, 'wintendo@ya.ru', '6f184a8fe4385e3e0e2d1404737bfb83', 1328961655),
(7, 0, 'A.n.d.r.o.n_@bk.ru', 'd476e25e84667abbfea4b3058ad396f2', 1328962332),
(8, 0, 'kontik.maio@yandex.ru', 'b17c079ce02fc73b3739a3e20276778b', 1328965242),
(9, 0, 'xanoi@bk.ru', '7f3e4cfc4115201a014cc4778d9251a0', 1328969876),
(10, 0, 'pritis.a@yandex.ru', '417cca3c6adb1ee95c6bef6f5b315dc4', 1328970372),
(11, 0, 'andiec05@ya.ru', 'd345dddd575c29c38c6c1ac33fbbf458', 1328972709),
(12, 0, 'fuckmix@spaces.ru', 'af35b0fcd9448390c557ffe331275e72', 1328973794),
(13, 0, 'wapik.ja@yandex.ru', 'ae9ebd52bc2082a5e76043fe00f5c508', 1328980519);

-- --------------------------------------------------------

--
-- Структура таблицы `rules`
--

CREATE TABLE IF NOT EXISTS `rules` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` char(128) NOT NULL,
  `text` text NOT NULL,
  `p` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Дамп данных таблицы `rules`
--

INSERT INTO `rules` (`id`, `name`, `text`, `p`) VALUES
(1, 'Общие правила поведения на сайте', 'Начнем с того, что на сайте общаются люди, разных религий и взглядов, и все они являются полноправными посетителями нашего сайта, поэтому если мы хотим чтобы это сообщество людей функционировало нам и необходимы правила. Мы настоятельно рекомендуем прочитать настоящие правила, это займет у вас всего минут пять, но сбережет нам и вам время и поможет сделать сайт более интересным и организованным.\r\nНа нашем сайте нужно вести себя уважительно ко всем посетителям сайта. Не надо оскорблений по отношению к участникам, это всегда лишнее. Если есть претензии - обращайтесь к Админам или Модераторам (воспользуйтесь личными сообщениями). Оскорбление других посетителей считается у нас одним из самых тяжких нарушений и строго наказывается администрацией. У нас строго запрещен расизм, религиозные и политические высказывания. Заранее благодарим вас за понимание и за желание сделать наш сайт более вежливым и дружелюбным.', 1),
(2, 'На сайте строго запрещено', '- сообщения, не относящиеся к содержанию статьи или к контексту обсуждения\r\n- оскорбление и угрозы в адрес посетителей сайта\r\n- в комментариях запрещаются выражения, содержащие ненормативную лексику, унижающие человеческое достоинство, разжигающие межнациональную рознь\r\n- спам, а также реклама любых товаров и услуг, иных ресурсов, СМИ или событий, не относящихся к контексту обсуждения статьи\r\n\r\nДавайте будем уважать друг друга и сайт, на который Вы и другие читатели приходят пообщаться и высказать свои мысли. Администрация сайта оставляет за собой право удалять комментарии или часть комментариев, если они не соответствуют данным требованиям.\r\n\r\nПри нарушении правил вам может быть дано предупреждение. В некоторых случаях может быть дан бан без предупреждений. По вопросам снятия бана писать администратору.\r\n\r\nОскорбление администраторов или модераторов также караются баном - уважайте чужой труд.', 0);

-- --------------------------------------------------------

--
-- Структура таблицы `setting`
--

CREATE TABLE IF NOT EXISTS `setting` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` char(128) NOT NULL,
  `value` char(255) NOT NULL,
  `act` char(32) DEFAULT 'autoload',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ROW_FORMAT=FIXED AUTO_INCREMENT=42 ;

--
-- Дамп данных таблицы `setting`
--

INSERT INTO `setting` (`id`, `name`, `value`, `act`) VALUES
(1, 'str', '6', 'autoload'),
(2, 'translit', '0', 'autoload'),
(3, 'title', 'iNFcms', 'autoload'),
(4, 'style', 'default', 'autoload'),
(5, 'sdvig', '0', 'autoload'),
(6, 'texthome', 'WAP движок для сайта...', 'autoload'),
(7, 'reg_mail', 'deniscurtis@mail.ru', 'autoload'),
(8, 'meta_d', 'скрипты скрипты wap php скрипты скрипты php скачать php скрипты ява скрипты wap скрипты java скрипты java скрипты для сайта скрипты сайтов скрипты для сайта вап мастеру вап мастер wap мастер wap master wapmaster создание сайта шаблоны DCMS johncms движки', 'autoload'),
(9, 'meta_k', 'скрипты скрипты wap php скрипты скрипты php скачать php скрипты ява скрипты wap скрипты java скрипты java скрипты для сайта скрипты сайтов скрипты для сайта вап мастеру вап мастер wap мастер wap master wapmaster создание сайта шаблоны DCMS johncms движки', 'autoload'),
(10, 'url_home', 'infdev.ru', 'autoload'),
(11, 'copy', 'Eclair', 'autoload'),
(12, 'path', 'files', 'load'),
(13, 'opath', 'about', 'load'),
(14, 'spath', 'screen', 'load'),
(15, 'jpath', 'data/jar', 'load'),
(16, 'zpath', 'data/zip', 'load'),
(17, 'tpath', 'data/theme', 'load'),
(18, 'mp3path', 'data/mp3', 'load'),
(19, 'vpath', 'data/video', 'load'),
(20, 'on_main', '0', 'autoload'),
(24, 'delete_dir', '1', 'load'),
(25, 'delete_file', '1', 'load'),
(27, 'zip_change', '1', 'load'),
(28, 'jad_change', '1', 'load'),
(29, 'cut_change', '1', 'load'),
(30, 'komm', '1', 'load'),
(31, 'lib_root', 'Различные статьи', 'lib'),
(37, 'prev_size', '50*50', 'load'),
(38, 'marker', '1', 'load'),
(39, 'text_marker', 'e-engine.ru', 'load'),
(40, 'day_new', '3', 'load'),
(41, 'sort', 'data', 'load');

-- --------------------------------------------------------

--
-- Структура таблицы `styles`
--

CREATE TABLE IF NOT EXISTS `styles` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `dir` char(64) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `name` char(32) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `temp` char(128) DEFAULT 'default',
  `css` char(255) DEFAULT 'style.css',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Дамп данных таблицы `styles`
--

INSERT INTO `styles` (`id`, `dir`, `name`, `temp`, `css`) VALUES
(1, 'default', 'День', 'default', 'style/default.css'),
(2, 'moon', 'Ночь', 'default', 'style/moon.css');

-- --------------------------------------------------------

--
-- Структура таблицы `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `nick` char(32) COLLATE utf8_unicode_ci NOT NULL,
  `pass` char(75) COLLATE utf8_unicode_ci NOT NULL,
  `mail` char(64) COLLATE utf8_unicode_ci DEFAULT NULL,
  `avatar` char(15) COLLATE utf8_unicode_ci DEFAULT NULL,
  `pol` tinyint(1) NOT NULL DEFAULT '1',
  `status` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `wpost` int(11) DEFAULT '0',
  `wtheme` int(11) DEFAULT '0',
  `str` int(2) DEFAULT '5',
  `on_main` int(1) NOT NULL DEFAULT '0',
  `style` char(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'default',
  `datereg` int(11) DEFAULT '0',
  `life_time` text COLLATE utf8_unicode_ci NOT NULL,
  `karma` int(11) DEFAULT '0',
  `level` set('0','1','2','3','4') COLLATE utf8_unicode_ci DEFAULT '0',
  `ban` set('0','1') COLLATE utf8_unicode_ci DEFAULT '0',
  `ban_time` int(11) DEFAULT '0',
  `timeaut` int(11) DEFAULT '0',
  `ip` char(21) COLLATE utf8_unicode_ci NOT NULL,
  `browser` char(128) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=12 ;


-- --------------------------------------------------------

--
-- Структура таблицы `users_profile`
--

CREATE TABLE IF NOT EXISTS `users_profile` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` char(32) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `sname` char(32) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `o_sebe` varchar(500) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `dr` tinyint(2) NOT NULL DEFAULT '0',
  `mr` tinyint(2) NOT NULL DEFAULT '0',
  `gr` int(4) NOT NULL DEFAULT '0',
  `tel` varchar(11) DEFAULT NULL,
  `mail` varchar(64) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `icq` int(10) DEFAULT NULL,
  `skype` char(100) DEFAULT NULL,
  `jabber` char(100) DEFAULT NULL,
  `city` char(64) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `www` char(32) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;



-- --------------------------------------------------------

--
-- Структура таблицы `users_voice`
--

CREATE TABLE IF NOT EXISTS `users_voice` (
  `user` int(11) NOT NULL DEFAULT '0',
  `from` int(11) NOT NULL DEFAULT '0',
  `last_time` int(11) NOT NULL DEFAULT '0',
  KEY `user` (`user`,`last_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Дамп данных таблицы `users_voice`
--

INSERT INTO `users_voice` (`user`, `from`, `last_time`) VALUES
(4, 1, 1328961840),
(5, 1, 1328961964),
(6, 1, 1328973986),
(11, 1, 1328975782),
(11, 2, 1328976166);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
