<?php
@session_start();
@session_name('iNF');
@ob_start ();

if (defined('__IN_INF') && !defined('__IN_iNF')) define('__IN_iNF', 1);
defined('__IN_iNF') or die('ERROR: Restricted Access!');

if (isset($root_dir) == FALSE) $root_dir = '';
define('ROOT', $root_dir);

require (ROOT.'engine/config.php');
require (ROOT.'engine/functions.php');

/**
 *  Сжатие
 */
if (isset($_SERVER['HTTP_ACCEPT_ENCODING']) && preg_match('/^deflate/', $_SERVER['HTTP_ACCEPT_ENCODING']))
{
	header('Content-Encoding: deflate');
	ob_START('G_de');
}
elseif (isset($_SERVER['HTTP_ACCEPT_ENCODING']) && preg_match('/^gzip/', $_SERVER['HTTP_ACCEPT_ENCODING']))
{
	header('Content-Encoding: gzip');
	ob_START('G_en');
}

if (!$_set['on']) die(CLOSE_MSG);

/**
 *  BASE
 */
$db = new db;
$sql = new mysqli($config['dbhost'], $config['dbuser'], $config['dbpass'], $config['dbname']) or Die('MySQLi::ERROR нет соединения с бд');
$sql->query('SET NAMES `utf8`') or Die('Error: names');
mysql_connect($config['dbhost'],$config['dbuser'],$config['dbpass']) or error();
mysql_select_db($config['dbname']) or error();
mysql_query('SET NAMES utf8');
unset($config);

/**
 *  Константы
 */
define('START', MicroTime(TRUE));

Define('USER_TABLE', $PR.'users');
Define('USER_PROFILE_TABLE', $PR.'users_profile');
Define('USER_VOICE', $PR.'users_voice');

Define('SET_TABLE', $PR.'setting');
Define('BASE_INFO', $PR.'base_info');

Define('GUEST_BOOK', $PR.'guest');

Define('LIB', $PR.'lib');
Define('LIB_MODER', $PR.'lib_moder');

Define('LOAD_FILES', $PR.'files');
Define('LOAD_SCREEN', $PR.'files_screen');
Define('LOAD_KOMM', $PR.'files_komm');

Define('FOTO_ALBUM', $PR.'foto_album');
Define('FOTO_FILE', $PR.'foto_file');
Define('FOTO_KOMM', $PR.'foto_komm');
Define('FOTO_VOICE', $PR.'foto_voice');

Define('MAIL_TABLE', $PR.'mail');
Define('KL_TABLE', $PR.'kl');

Define('FORUM_POST', $PR.'forum_p');
Define('FORUM_THEME', $PR.'forum_t');
Define('FORUM_RAZDEL', $PR.'forum_r');
Define('FORUM', $PR.'forum_f');

Define('Mod', 1);
Define('Adm', 2);

/**
 *  сессия
 */

// время
$time = $_SERVER['REQUEST_TIME'];
define('ON_TIME', 180); // время онлайна

/**
 *   Безопасность
 */

if (isSet($_POST)) $_POST = array_map('amSQL', $_POST);
if (isSet($_GET)) $_GET = array_map('amSQL', $_GET);
if (isSet($_COOKIE)) $_COOKIE = array_map('amSQL', $_COOKIE);

/**
 *   Настройки
 */
$q = $db->query("SELECT name, value FROM setting WHERE act = 'autoload'") or die('Error: set');
while ($s = $db->get_row($q))
{
	$S[$s['name']] = $s['value'];
}

 // ip
	if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $_ip_ = iHtml($_SERVER['HTTP_X_FORWARDED_FOR']);
	elseif (isset($_SERVER['REMOTE_ADDR'])) $_ip_ = iHtml($_SERVER['REMOTE_ADDR']);
	else Die('ERROR! (ip)');
 // user-agent
 $_ua_ = mysql_real_escape_string($_SERVER['HTTP_USER_AGENT']);
 if (preg_match('/(Opera|Firefox|Safari|YandexBot|Googlebot|Googlebot-Mobile|MJ12bot|AhrefsBot|Flock|MSIE|K-Meleon|SeaMonkey|Camino|Firebird|Epiphany|Chrome|America Online Browser)[\/: ]([\d.]+)/', $_ua_, $out)) {
	 if ($out[1] == "MSIE") {
     $out[1] = "Internet Explorer";
    } 
    $_ua_ = $out[1] . " " . $out[2];
   }

# # # # # # # # # # # # # # #
$is_user = FALSE;
$is_moder = $is_admin = FALSE;
$is_post = $is_theme = FALSE;
$new_m = $new_a = 0;
$style = $S['style'];

/**
 *   пользователь
 */

	if ($_aut['cook'] == 1 && isSet($_COOKIE['u_id']) && isSet($_COOKIE['u_pass']))
	{
	    $Uid = (int)$_COOKIE['u_id'];
	    $Upass = iHtml($_COOKIE['u_pass']);
	}
    if ($_aut['sess'] == 1 && isSet($_SESSION['u_id']) && isSet($_SESSION['u_pass']))
	{
	    $Uid = (int)$_SESSION['u_id'];
	    $Upass = iHtml($_SESSION['u_pass']);
	}
 

$view = new phpTemp($sql, $S);


if (isSet($Uid))
{
$q = $db->query("SELECT * FROM users WHERE id = '{$Uid}' AND pass = '{$Upass}' LIMIT 1");

	if($q->num_rows > 0)
	{
		$user = $q->fetch_array();
		$is_user = TRUE;
		$u_id = $user['id'];
		$S['str'] = $user['str'];
		if ($user['on_main'] == 1) $is_on_main = TRUE;
		$S['on_main'] = $user['on_main'];
		$style = $user['style'];
		
		// время на сайте
		if ($user['life_time'] != '') {
			$lifestr = explode('|', $user['life_time']);
			$lifetime = time() - $lifestr[0];
			if ($lifetime < 600 and $lifetime > 2) {
				$usertime = $lifestr[1] + $lifetime;
			} else {
				$usertime = $lifestr[1];
			}
			if ($usertime > 0) {
				$write_tlife = time() . '|' . $usertime;
				$write_tlife = iHtml($write_tlife);
				$db->query("UPDATE users SET life_time = '{$write_tlife}' WHERE id = '{$user['id']}'");
			}
		} else {
			$write_tlife = time() . '|0';
			$write_tlife = iHtml($write_tlife);
			$db->query("UPDATE users SET life_time = '{$write_tlife}' WHERE id = '{$user['id']}'");
		}
				

		if ($user['level'] == 1) $is_moder = TRUE;
		if ($user['level'] == 2 || $user['level'] == 3 || $user['level'] == 4) $is_moder = $is_admin = $is_admin = TRUE;
        if ($user['wpost'] + wPOST < $time) $is_post = TRUE;
        if ($user['wtheme'] + wTHEME < $time) $is_theme = TRUE;

		$sql->query('UPDATE `'.USER_TABLE."` SET `ip` = '$_ip_', `browser` = '$_ua_', `timeaut` = '$time' WHERE `id` = '".$u_id."' LIMIT 1");
        // новые сообщения
		$new_m = one($sql->query('SELECT COUNT(*) as new_msg FROM `'.MAIL_TABLE."` WHERE `kont` = '".$u_id."' AND `read` = '0'")->fetch_array());
		$new_a = one($sql->query("SELECT COUNT(*) as new_act FROM `new_action` WHERE `user` = '".$u_id."' AND `read` = '0'")->fetch_array());
	} 
	else
	{
		UnSet($_SESSION['u_id']);
		UnSet($_SESSION['u_pass']);
		SetCookie('u_id', '');
		SetCookie('u_pass', '');
	}
}
    $style = $sql->query("SELECT * FROM `styles` WHERE `dir` = '$style' LIMIT 1")->fetch_array();
    $view->tempEdit($style['temp']);

// доп. код

DeFINE('NEW_MSG', $new_m);
DeFINE('NEW_ACTION', $new_a);
DeFINE('STYLE', $style['dir']);
DeFINE('STYLE_CSS', '/template/'.$view->nameTemp.'/'.$style['css']);

    if ($is_user && $user['ban'] == 1 && $user['ban_time'] > $time)
    {
    	$ban = new ban($user['id']);
    	$ban->msg($user['id'], $user['ban_time']);
    }
?>